/** @file
 * @brief Internal structures definition for VIO -- This is *not* the public API.
 * @ingroup VIO
 */

/** @defgroup VIO Service: VIO -- PadicoTM virtual I/O
 * @author Alexandre Denis
 */

#include <Padico/Puk.h>
#include <Padico/PadicoTM.h>
#include <Padico/PM2.h>
#include <Padico/Topology.h>

#include "PadicoTM_config.h"

#include "VIO.h"
#include "VLink-API.h"

#ifndef VIO_INTERNALS_H
#define VIO_INTERNALS_H

#if defined(PUKABI) && defined(PADICO_ENABLE_PUKABI_FSYS)
/** whether to plug VIO into PukABI */
#define VIO_PUK_ABI 1
#endif


/** Attach a VIO file descriptor to a vnode 
 */
void vio_store_desc(padico_vnode_t vnode, int vfd);

#endif /* VIO_INTERNALS_H */
