dnl -*- mode: Autoconf;-*-

# ## detect padico building-tools
AC_DEFUN([AC_PADICO_BUILDING_TOOLS],
	 [
	   AC_MSG_CHECKING([for common building-tools])
	   if test -r ${srcdir}/building-tools/common_rules.mk.in; then
	     building_tools=${srcdir}/building-tools/
	   elif test -r ${srcdir}/../building-tools/common_rules.mk.in; then
	     building_tools=${srcdir}/../building-tools/
 	   else
	     AC_MSG_ERROR([missing building-tools directory in srcdir: ${srcdir}])
	   fi
	   AC_MSG_RESULT([${building_tools}])
	   AC_SUBST([building_tools])
	 ])

# ## set package name
AC_DEFUN([AC_PADICO_PACKAGE],
	 [
	   AC_MSG_CHECKING([for package name])
	   package_name="$1"
	   package_short_name="$2"
	   if test "x${package_short_name}" = "x"; then
	     package_short_name="${package_name}"
	   fi
	   PACKAGE_NAME="${package_name}"
	   if test "x${PACKAGE_NAME}" = "x"; then
	     AC_MSG_ERROR([ cannot find package name. ])
	   else
	     AC_MSG_RESULT([${package_name} (${package_short_name})])
	   fi
	   AC_SUBST([package_name])
	   AC_SUBST([package_short_name])
	 ])

# ## set package root
AC_DEFUN([AC_PADICO_PACKAGE_ROOT],
	 [
	   AC_REQUIRE([AC_PADICO_PACKAGE])
	   AC_MSG_CHECKING([for package root])
           if test x$prefix = xNONE; then
             AC_MSG_ERROR([No prefix given. Please supply a '--prefix' parameter.])
           fi
	   padico_root=${prefix}
           AC_MSG_RESULT([${padico_root})])
	   AC_SUBST([padico_root])
	 ])

# ## check build directory
AC_DEFUN([AC_PADICO_BUILDDIR],
	 [
	   AC_REQUIRE([AC_PADICO_PACKAGE])
	   AC_MSG_CHECKING([for package build directory])
	   padico_builddir=`pwd`
	   if test -r ./configure; then
	     AC_MSG_ERROR([ *** ${PACKAGE_NAME} must not be configured in its source tree. Create a separate 'build' dir instead. ])
	   fi
	   AC_SUBST(padico_builddir)
	   AC_MSG_RESULT(${padico_builddir})
	 ])
# ## check source directory
AC_DEFUN([AC_PADICO_SRCDIR],
	 [
	   AC_REQUIRE([AC_PADICO_PACKAGE])
	   AC_MSG_CHECKING([for package ${PACKAGE_NAME} source directory])
	   case ${srcdir} in
	     /*) padico_srcdir=${srcdir} ;;
	     *)  padico_srcdir="`pwd`/${srcdir}" ;;
	   esac
	   AC_SUBST(padico_srcdir)
	   AC_MSG_RESULT(${padico_srcdir})
	 ])

# ## Version and version strings
AC_DEFUN([AC_PADICO_VERSION],
	 [
	   AC_REQUIRE([AC_PADICO_BUILDING_TOOLS])
	   AC_REQUIRE([AC_PADICO_PACKAGE])
           AC_REQUIRE([AC_PADICO_SRCDIR])
           AC_MSG_CHECKING([${PACKAGE_NAME} version])
	   if test -r ${building_tools}/VERSION; then
	     PACKAGE_VERSION="`cat ${building_tools}/VERSION`"
 	   else
	     AC_MSG_ERROR([ cannot find VERSION. ])
           fi
	   PACKAGE_STRING="${PACKAGE_NAME}-${PACKAGE_VERSION}"
 	   PACKAGE_TARNAME="${PACKAGE_STRING}.tar.gz"
           PACKAGE_BUGREPORT="<Alexandre.Denis@inria.fr>"

	   AC_MSG_RESULT([ $PACKAGE_STRING ])

	   PADICO_VERSION=${PACKAGE_VERSION}
	   AC_SUBST(PADICO_VERSION)

           padico_build_string="${PACKAGE_STRING} (`date`)"
	   AC_DEFINE_UNQUOTED(PADICO_BUILD_STRING, "${padico_build_string}", [date of the build])

	   AC_DEFINE_UNQUOTED(PADICO_VERSION_STRING, "${PACKAGE_STRING}",
			      [Padico version as string])
	 ])
