/*
 * NewMadeleine
 * Copyright (C) 2006-2019 (see AUTHORS file)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 */


#include <stdlib.h>
#include <stdio.h>
#include <stdint.h>
#include <string.h>
#include <unistd.h>

#include "../common/nm_examples_helper.h"

#define BILLION 1000000000L

#define NB_BARRIERS 1000

int main(int argc, char**argv)
{ 
  nm_examples_init(&argc, argv);

  nm_group_t p_group = nm_comm_group(p_comm);
  const int self = nm_group_rank(p_group);
  const nm_tag_t tag = 0x42;

  struct timespec t_before, t_after;
  clock_gettime(CLOCK_MONOTONIC, &t_before);


  for(int i = 0; i < NB_BARRIERS; i++)
    {
      struct nm_coll_barrier_s*p_barrier = nm_coll_group_ibarrier(p_session, p_group, self, tag);
      nm_coll_ibarrier_wait(p_barrier);
    }

  clock_gettime(CLOCK_MONOTONIC, &t_after);

  uint64_t diff = BILLION * (t_after.tv_sec - t_before.tv_sec) + t_after.tv_nsec - t_before.tv_nsec;

  printf("[%d] latency: %llu\n", self, (long long unsigned int) diff / (NB_BARRIERS * 2)) ;
  
  nm_examples_exit();
  exit(0);
}
