
#include <math.h>
#include <stdio.h>
#include <nm_sendrecv_interface.h>
#include <nm_coll_trees.h>

int main(int argc, char**argv)
{
  int i;
  const int n = 32;
  const int root = 0;
  struct nm_coll_tree_info_s trees[n];
  int*children[n];

  fprintf(stderr, "# n = %d\n", n);
  for(i = 0; i < n; i++)
    {
      nm_coll_tree_init(&trees[i], NM_COLL_TREE_BINOMIAL, n, i, root);
      children[i] = malloc(sizeof(int) * trees[i].max_arity);
    }
  
  int step;
  for(step = 0; step < trees[0].height; step++)
    {
      fprintf(stderr, "step = %d\n", step);
      for(i = 0; i < n; i++)
        {
          int parent = -1;
          int n_children = 0;
          nm_coll_tree_step(&trees[i], step, &parent, children[i], &n_children);
          fprintf(stderr, "  i = %d; child = %d; parent = %d; weight = %d\n",
                  i, (n_children > 0) ? *children[i]:-1, parent,
                  nm_coll_binomial_weight(i, n, trees[0].height - step - 1));
        }
      
    }
  
  return 0;
}
