/*
 * PM2: Parallel Multithreaded Machine
 * Copyright (C) 2008-2018 "the PM2 team" (see AUTHORS file)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 */

#include "piom_private.h"


#ifdef PIOMAN_NOTHREAD

static int piom_nothread_dispatching = 0;

void piom_ltask_nothread_init(void)
{
}

void piom_ltask_nothread_exit(void)
{
}

void piom_ltask_nothread_hook_preinvoke(void)
{
  piom_nothread_dispatching++;
}
void piom_ltask_nothread_hook_postinvoke(void)
{
  piom_nothread_dispatching--;
}

void piom_ltask_nothread_check_wait(void)
{
  if(piom_nothread_dispatching > 0)
    {
      fprintf(stderr, "pioman: deadlock detected- cannot wait while dispatching ltask.\n");
      abort();
    }
}


#endif /* PIOMAN_NOTHREAD */
